package cn.com.poc.agent_application.rest.impl;

import cn.com.poc.agent_application.convert.BizAgentApplicationPluginConvert;
import cn.com.poc.agent_application.dto.AgentApplicationPluginDto;
import cn.com.poc.agent_application.entity.BizAgentApplicationPluginEntity;
import cn.com.poc.agent_application.rest.BizAgentApplicationPluginRest;
import cn.com.poc.agent_application.service.BizAgentApplicationPluginService;
import cn.com.poc.common.constant.CommonConstant;
import cn.com.yict.framemax.core.context.Context;
import cn.com.yict.framemax.core.i18n.I18nMessageException;
import cn.com.yict.framemax.data.model.PagingInfo;
import cn.hutool.core.util.ObjectUtil;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Locale;
import java.util.stream.Collectors;

@Component
public class BizAgentApplicationPluginRestImpl implements BizAgentApplicationPluginRest {

    @Resource
    private BizAgentApplicationPluginService bizAgentApplicationPluginService;

    @Override
    public AgentApplicationPluginDto getByPluginId(String pluginId) throws Exception {
        Locale currentLocale = Context.get().getMessageSource().getCurrentLocale();
        BizAgentApplicationPluginEntity bizAgentApplicationPluginEntity = new BizAgentApplicationPluginEntity();
        bizAgentApplicationPluginEntity.setPluginId(pluginId);
        BizAgentApplicationPluginEntity entity = bizAgentApplicationPluginService.getInfoById(pluginId);
        if (ObjectUtil.isEmpty(entity)) {
            //todo
            throw new I18nMessageException("");
        }
        return BizAgentApplicationPluginConvert.entityToDto(entity, currentLocale.toLanguageTag().toLowerCase());
    }

    @Override
    public List<AgentApplicationPluginDto> getList(String classificationName, PagingInfo pagingInfo) throws Exception {
        Locale currentLocale = Context.get().getMessageSource().getCurrentLocale();
        BizAgentApplicationPluginEntity bizAgentApplicationPluginEntity = new BizAgentApplicationPluginEntity();
        bizAgentApplicationPluginEntity.setIsDeleted(CommonConstant.IsDeleted.N);
        List<BizAgentApplicationPluginEntity> entities = bizAgentApplicationPluginService.findByExample(bizAgentApplicationPluginEntity, pagingInfo);
        return BizAgentApplicationPluginConvert.entitiesToDtos(entities.stream().filter(entity -> !"system".equals(entity.getClassification())).collect(Collectors.toList()), currentLocale.toLanguageTag().toLowerCase());
    }

    @Override
    public List<String> classificationList() throws Exception {
        return null;
    }
}